javax.enterprise.inject.spi

## Interface ProcessAnnotatedType<X>

- Type Parameters:
    `X` - The class being annotated
  All Known Subinterfaces:
    ProcessSyntheticAnnotatedType<X>

      public interface ProcessAnnotatedType<X>

  The container fires an event of this type for each Java class or interface it discovers in a bean archive, before it reads the declared annotations.

  Any observer of this event is permitted to wrap and/or replace the `AnnotatedType`. The container must use the final value of this property, after all observers have been called, to discover the types and read the annotations of the program elements.

  For example, the following observer decorates the `AnnotatedType` for every class that is discovered by the container.

       public <T> void decorateAnnotatedType(@Observes ProcessAnnotatedType<T> pat) {
           pat.setAnnotatedType(decorate(pat.getAnnotatedType()));
       }

  If any observer method of a `ProcessAnnotatedType` event throws an exception, the exception is treated as a definition error by the container.

  Author:
    David Allen
  See Also:
    `AnnotatedType`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AnnotatedType<X>` | `getAnnotatedType()` Returns the `AnnotatedType` object that will be used by the container to read the declared annotations.
    `void` | `setAnnotatedType(AnnotatedType<X> type)` Replaces the `AnnotatedType`.
    `void` | `veto()` Forces the container to ignore this type.

- - ### Method Detail

    - #### getAnnotatedType

          AnnotatedType<X> getAnnotatedType()

      Returns the `AnnotatedType` object that will be used by the container to read the declared annotations.
      Returns:
        the `AnnotatedType` object
      Throws:
        `IllegalStateException` - if called outside of the observer method invocation

    - #### setAnnotatedType

          void setAnnotatedType(AnnotatedType<X> type)

      Replaces the `AnnotatedType`.
      Parameters:
        `type` - the new `AnnotatedType` object to use
      Throws:
        `IllegalStateException` - if called outside of the observer method invocation

    - #### veto

          void veto()

      Forces the container to ignore this type.
      Throws:
        `IllegalStateException` - if called outside of the observer method invocation

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.